import React from 'react';
import AppBar from '@mui/material/AppBar';
import Box from '@mui/material/Box';
import Toolbar from '@mui/material/Toolbar';
import Typography from '@mui/material/Typography';
import Button from '@mui/material/Button';
import IconButton from '@mui/material/IconButton';
import MenuIcon from '@mui/icons-material/Menu';
import { Outlet, Link } from "react-router-dom";

const mainmenuItems = [
  { text: 'Home', href: '/' },
  { text: 'Try1', href: '/try1' },
  { text: 'Try2', href: '/try2' }
]

const HeaderAppBar = () => {
  return (
    <Box sx={{ flexGrow: 1 }}>
      <AppBar position="static">
        <Toolbar>
          <IconButton
            size="large"
            edge="start"
            color="inherit"
            aria-label="menu"
            sx={{ mr: 2 }}
          >
            <MenuIcon />
          </IconButton>
          <Typography variant="h6" component="div" sx={{ flexGrow: 1 }}>
            Self-learning Project
          </Typography>
          {
            mainmenuItems.map((item, idx) => {
              return (
                <React.Fragment key={item.href}>
                  <Button component={Link} to={item.href} color="inherit">{item.text}</Button>
                </React.Fragment>)
            })
          }
        </Toolbar>
      </AppBar>
    </Box>
  );
}

export default function Header() {
  return (
    <>
      <HeaderAppBar />
      <Box sx={{ m: 2 }} />
    </>
  )
};
