import React, { Component } from 'react';
import { AppContext, AppState } from './context/AppContext';
import Counter from './components/Counter';
import { SlaveConsumer, SlaveContextType } from './components/Slaves';
import './Try1.css';
import { Box, Grid } from '@mui/material';
import Master from './components/Master';

class App extends Component<any, AppState> {

  constructor(props: any) {
    super(props);
    this.state = {
      test: {
        name: "XYZ",
        value: 123,
      }
    };
  }

  update = (appState: any) => {
    this.setState(prevState => (appState))
    // let thePrevstate;
    // this.setState(prevState => {
    //   thePrevstate = prevState;
    //   return appState;
    // });
    // return thePrevstate;
  };

  render() {
    const { update } = this;
    const appState = this.state;

    return (
      <div className="container">
        <AppContext.Provider value={{ appState, update }} >
          <Counter title="Test Counter" />
          <Box sx={{ m: 2 }} />
          <Grid container spacing={2}>
            <Grid item md={4}>
              <Master></Master>
            </Grid>
            <Grid item md={4}>
              <SlaveConsumer></SlaveConsumer>
            </Grid>
            <Grid item md={4}>
              <SlaveContextType></SlaveContextType>
            </Grid>
          </Grid>
        </AppContext.Provider>
      </div>
    );
  }
}

export default App;
