import React, { Component } from 'react';
import Widget from '../../components/Widget';

type CounterProps = {
    title: string;
};

type CounterState = {
    value: number;
};

class Counter extends Component<CounterProps, CounterState> {
    // constructor(props: CounterProps) {
    //     super(props);
    //     this.state = {
    //         value: 0,
    //     }
    // }

    state: CounterState = {
        value: 0,
    };

    incByOne = (
        event: React.MouseEvent<HTMLButtonElement, MouseEvent>,
    ) => {
        this.setState(prevState => ({
            value: prevState.value + 1
        }));
    }

    render() {
        const { value } = this.state;
        return (
            <Widget headerTitle={this.props.title} actionBtnTitle='+1' onActionBtnClicked={this.incByOne}>
                Current Value in State: {value}
            </Widget>
        );
    }
}

export default Counter;