import React, { Component } from 'react';
import Widget from '../../components/Widget';
import { AppContext } from '../context/AppContext';

const ChildWidget = (props: any) => {
    // context via Hooks
    // Note: 'useContext' should only be used in functional component, not class comp.
    const ctx = React.useContext(AppContext);
    return (
        <Widget headerTitle='Child' >
            <p>Prop:pTest = {props.pTest}</p>
            <p>Ctx:Name = {ctx!.appState!.test.name}</p>
            <p>Ctx:Value = {ctx!.appState!.test.value}</p>
        </Widget>
    );
}

// Class Component
class Master extends Component {
    // Set the context
    static contextType = AppContext;
    context!: React.ContextType<typeof AppContext>;

    setCtxClicked = () => {
        const { update } = this.context!;
        update({
            test: {
                value: 9,
            }
        })
    }

    render() {
        const { appState } = this.context!;

        console.log("-------PROP----");
        console.log(this.props);
        console.log("-------State----");
        console.log(this.state);
        // console.log("-------Context----");
        return (
            <Widget headerTitle='Master' actionBtnTitle='Set Ctx' onActionBtnClicked={this.setCtxClicked}>
                <p>Ctx:Name = {appState!.test.name}</p>
                <p>Ctx:Value = {appState!.test.value}</p>
                <ChildWidget />
            </Widget>
        );
    }
}

export default Master;