import React, { Component } from 'react';
import Widget from '../../components/Widget';
import { AppContext } from '../context/AppContext';
// import { AppContextType } from '../context/AppContext';


// Class Component
// context via Consumer
class SlaveConsumer extends Component {
    render() {
        return (
            <AppContext.Consumer>
                {value => (
                    <Widget headerTitle='Slave via Consumer' >
                        <p>Ctx:Name = {value!.appState!.test.name}</p>
                        <p>Ctx:Value = {value!.appState!.test.value}</p>
                    </Widget>
                )}
            </AppContext.Consumer>

        )
    }
}

// Class Component
// context via contextType
class SlaveContextType extends Component {
    context!: React.ContextType<typeof AppContext>;
    render() {
        return (
            <Widget headerTitle='Slave via ContextType' >
                <p>Ctx:Name = {this.context!.appState!.test.name}</p>
                <p>Ctx:Value = {this.context!.appState!.test.value}</p>
            </Widget>
        )
    }
}
SlaveContextType.contextType = AppContext;


export { SlaveConsumer, SlaveContextType };