import React, { createContext, useEffect, useState } from 'react';
import './Try2.css';

import Container from '@mui/material/Container';
import { Card1 } from './components/Cards';
import { Box, Button } from '@mui/material';

type CardContent = {
  content: string
}

const defaultCardContent = { content: '' };

// create context
const SharedCardContext = createContext<CardContent>(defaultCardContent);

function Try2App() {
  // the value that will be given to the context
  const [cardContent, setCardContent] = useState<CardContent>(defaultCardContent);
  useEffect(() => {
    setCardContent({ content: 'David'});
  },[]);

  const handleChangeCtx = () => {
    console.log(cardContent)
    setCardContent({ content: cardContent.content + ' !'});
  }
  
  return (
    <Container maxWidth="sm">
      <SharedCardContext.Provider value={cardContent}>
        <Card1 title='Card One'></Card1>
        <Box sx={{ m: 0.5 }} />
        <Card1 title='Card Two'></Card1>
      </SharedCardContext.Provider>
      <Box sx={{ m: 2 }} />
      <Button variant="contained" onClick={handleChangeCtx}>!</Button>
    </Container>
  );
}

export { Try2App, SharedCardContext };
