import React, { useContext } from 'react';
import { SharedCardContext } from '../Try2';
import Widget from '../../components/Widget';

// Card1 is a functional component and use "useContext"

type Card1Props = {
    title?: string
}

const Card1: React.FC<Card1Props> = (props) => {

    // access the context value
    const cardContent = useContext(SharedCardContext);

    return (
        <Widget headerTitle={props.title} >
            {cardContent.content}
        </Widget>

    );
}

// Card1.defaultProps = {
//     title: ''
// };



export { Card1 };
