import React, { useContext } from 'react';
import Card from '@mui/material/Card';
import CardActions from '@mui/material/CardActions';
import CardContent from '@mui/material/CardContent';
import { CardHeader, Grid } from '@mui/material';
import Button from '@mui/material/Button';
import { SharedCardContext } from '../Try2';

type Card1Props = {
    title?: string
}

const Card1: React.FC<Card1Props> = (props) => {
    const headerTitle = props.title;
    let hasHeaderTitle = (headerTitle && headerTitle.length > 0);

    // access the context value
    const cardContent = useContext(SharedCardContext);

    return (
        <Card sx={{ minWidth: 275 }} variant="outlined">
            {hasHeaderTitle &&
                <CardHeader title={props.title} />
            }
            <CardContent>
                <Grid container spacing={2}>
                    <Grid item md={6}>
                        Context Content:
                    </Grid>
                    <Grid item md={6}>
                        {cardContent.content}
                    </Grid>
                </Grid>
            </CardContent>
            <CardActions>
                <Button variant="contained">Change CTX</Button>
            </CardActions>
        </Card>
    );
}

// Card1.defaultProps = {
//     title: ''
// };

export { Card1 };
